blob: 0055b07b03b68cafd0bc3c400ee23b686632efbf [file] [log] [blame]
Jamey Sharp153f0112011-05-05 12:03:47 -07001#!/bin/sh
Linus Torvalds1da177e2005-04-16 15:20:36 -07002# Copyright (C) Martin Schlemmer <azarah@nosferatu.za.org>
Oleg Verychf6112ec2007-02-06 02:18:20 +01003# Copyright (C) 2006 Sam Ravnborg <sam@ravnborg.org>
Sam Ravnborgd39a206b2006-04-11 13:24:32 +02004#
Linus Torvalds1da177e2005-04-16 15:20:36 -07005# Released under the terms of the GNU GPL
6#
Sam Ravnborgd39a206b2006-04-11 13:24:32 +02007# Generate a cpio packed initramfs. It uses gen_init_cpio to generate
Alain Knaffa26ee602009-01-07 00:10:27 -08008# the cpio archive, and then compresses it.
Sam Ravnborgd39a206b2006-04-11 13:24:32 +02009# The script may also be used to generate the inputfile used for gen_init_cpio
10# This script assumes that gen_init_cpio is located in usr/ directory
11
12# error out on errors
13set -e
14
15usage() {
16cat << EOF
17Usage:
18$0 [-o <file>] [-u <uid>] [-g <gid>] {-d | <cpio_source>} ...
Alain Knaffa26ee602009-01-07 00:10:27 -080019 -o <file> Create compressed initramfs file named <file> using
20 gen_init_cpio and compressor depending on the extension
Sam Ravnborgd39a206b2006-04-11 13:24:32 +020021 -u <uid> User ID to map to user ID 0 (root).
Mike Frysinger4c6f2eb2007-05-10 22:44:28 -070022 <uid> is only meaningful if <cpio_source> is a
23 directory. "squash" forces all files to uid 0.
Sam Ravnborgd39a206b2006-04-11 13:24:32 +020024 -g <gid> Group ID to map to group ID 0 (root).
Mike Frysinger4c6f2eb2007-05-10 22:44:28 -070025 <gid> is only meaningful if <cpio_source> is a
26 directory. "squash" forces all files to gid 0.
Sam Ravnborgd39a206b2006-04-11 13:24:32 +020027 <cpio_source> File list or directory for cpio archive.
Oleg Verychf6112ec2007-02-06 02:18:20 +010028 If <cpio_source> is a .cpio file it will be used
Sam Ravnborgd39a206b2006-04-11 13:24:32 +020029 as direct input to initramfs.
30 -d Output the default cpio list.
31
32All options except -o and -l may be repeated and are interpreted
33sequentially and immediately. -u and -g states are preserved across
34<cpio_source> options so an explicit "-u 0 -g 0" is required
35to reset the root/group mapping.
36EOF
37}
38
Oleg Verychf6112ec2007-02-06 02:18:20 +010039# awk style field access
40# $1 - field number; rest is argument string
41field() {
42 shift $1 ; echo $1
43}
44
Sam Ravnborgd39a206b2006-04-11 13:24:32 +020045list_default_initramfs() {
46 # echo usr/kinit/kinit
47 :
48}
Linus Torvalds1da177e2005-04-16 15:20:36 -070049
50default_initramfs() {
Sam Ravnborgd39a206b2006-04-11 13:24:32 +020051 cat <<-EOF >> ${output}
Linus Torvalds1da177e2005-04-16 15:20:36 -070052 # This is a very simple, default initramfs
53
54 dir /dev 0755 0 0
55 nod /dev/console 0600 0 0 c 5 1
56 dir /root 0700 0 0
Sam Ravnborgd39a206b2006-04-11 13:24:32 +020057 # file /kinit usr/kinit/kinit 0755 0 0
58 # slink /init kinit 0755 0 0
Linus Torvalds1da177e2005-04-16 15:20:36 -070059 EOF
60}
61
62filetype() {
63 local argv1="$1"
64
65 # symlink test must come before file test
66 if [ -L "${argv1}" ]; then
67 echo "slink"
68 elif [ -f "${argv1}" ]; then
69 echo "file"
70 elif [ -d "${argv1}" ]; then
71 echo "dir"
72 elif [ -b "${argv1}" -o -c "${argv1}" ]; then
73 echo "nod"
74 elif [ -p "${argv1}" ]; then
75 echo "pipe"
76 elif [ -S "${argv1}" ]; then
77 echo "sock"
78 else
79 echo "invalid"
80 fi
81 return 0
82}
83
Sam Ravnborgd39a206b2006-04-11 13:24:32 +020084list_print_mtime() {
85 :
Linus Torvalds1da177e2005-04-16 15:20:36 -070086}
87
Sam Ravnborgd39a206b2006-04-11 13:24:32 +020088print_mtime() {
89 local my_mtime="0"
90
91 if [ -e "$1" ]; then
92 my_mtime=$(find "$1" -printf "%T@\n" | sort -r | head -n 1)
93 fi
94
95 echo "# Last modified: ${my_mtime}" >> ${output}
96 echo "" >> ${output}
97}
98
99list_parse() {
Michal Marek590abbd2016-09-23 09:56:05 +0200100 if [ -L "$1" ]; then
101 return
102 fi
103 echo "$1" | sed 's/:/\\:/g; s/$/ \\/'
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200104}
105
106# for each file print a line in following format
107# <filetype> <name> <path to file> <octal mode> <uid> <gid>
108# for links, devices etc the format differs. See gen_init_cpio for details
Linus Torvalds1da177e2005-04-16 15:20:36 -0700109parse() {
110 local location="$1"
Jamey Sharp153f0112011-05-05 12:03:47 -0700111 local name="/${location#${srcdir}}"
Linus Torvalds1da177e2005-04-16 15:20:36 -0700112 # change '//' into '/'
Jamey Sharp153f0112011-05-05 12:03:47 -0700113 name=$(echo "$name" | sed -e 's://*:/:g')
Linus Torvalds1da177e2005-04-16 15:20:36 -0700114 local mode="$2"
115 local uid="$3"
116 local gid="$4"
117 local ftype=$(filetype "${location}")
118 # remap uid/gid to 0 if necessary
Mike Frysinger4c6f2eb2007-05-10 22:44:28 -0700119 [ "$root_uid" = "squash" ] && uid=0 || [ "$uid" -eq "$root_uid" ] && uid=0
120 [ "$root_gid" = "squash" ] && gid=0 || [ "$gid" -eq "$root_gid" ] && gid=0
Linus Torvalds1da177e2005-04-16 15:20:36 -0700121 local str="${mode} ${uid} ${gid}"
122
Jamey Sharp153f0112011-05-05 12:03:47 -0700123 [ "${ftype}" = "invalid" ] && return 0
124 [ "${location}" = "${srcdir}" ] && return 0
Linus Torvalds1da177e2005-04-16 15:20:36 -0700125
126 case "${ftype}" in
127 "file")
128 str="${ftype} ${name} ${location} ${str}"
129 ;;
130 "nod")
Oleg Verychf6112ec2007-02-06 02:18:20 +0100131 local dev=`LC_ALL=C ls -l "${location}"`
132 local maj=`field 5 ${dev}`
133 local min=`field 6 ${dev}`
134 maj=${maj%,}
Linus Torvalds1da177e2005-04-16 15:20:36 -0700135
Oleg Verychf6112ec2007-02-06 02:18:20 +0100136 [ -b "${location}" ] && dev="b" || dev="c"
137
138 str="${ftype} ${name} ${str} ${dev} ${maj} ${min}"
Linus Torvalds1da177e2005-04-16 15:20:36 -0700139 ;;
140 "slink")
Felix Fietkaub5a5e4c2008-04-02 14:50:05 +0200141 local target=`readlink "${location}"`
Linus Torvalds1da177e2005-04-16 15:20:36 -0700142 str="${ftype} ${name} ${target} ${str}"
143 ;;
144 *)
145 str="${ftype} ${name} ${str}"
146 ;;
147 esac
148
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200149 echo "${str}" >> ${output}
Linus Torvalds1da177e2005-04-16 15:20:36 -0700150
151 return 0
152}
153
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200154unknown_option() {
155 printf "ERROR: unknown option \"$arg\"\n" >&2
156 printf "If the filename validly begins with '-', " >&2
157 printf "then it must be prefixed\n" >&2
158 printf "by './' so that it won't be interpreted as an option." >&2
159 printf "\n" >&2
160 usage >&2
161 exit 1
Linus Torvalds1da177e2005-04-16 15:20:36 -0700162}
163
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200164list_header() {
Thomas Choua26d79c2006-11-25 11:09:18 -0800165 :
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200166}
Linus Torvalds1da177e2005-04-16 15:20:36 -0700167
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200168header() {
169 printf "\n#####################\n# $1\n" >> ${output}
170}
Linus Torvalds1da177e2005-04-16 15:20:36 -0700171
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200172# process one directory (incl sub-directories)
173dir_filelist() {
174 ${dep_list}header "$1"
175
176 srcdir=$(echo "$1" | sed -e 's://*:/:g')
Michael Ellermaneda890a2007-04-30 15:34:15 +1000177 dirlist=$(find "${srcdir}" -printf "%p %m %U %G\n")
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200178
179 # If $dirlist is only one line, then the directory is empty
180 if [ "$(echo "${dirlist}" | wc -l)" -gt 1 ]; then
181 ${dep_list}print_mtime "$1"
182
183 echo "${dirlist}" | \
184 while read x; do
185 ${dep_list}parse ${x}
186 done
187 fi
188}
189
190# if only one file is specified and it is .cpio file then use it direct as fs
191# if a directory is specified then add all files in given direcotry to fs
192# if a regular file is specified assume it is in gen_initramfs format
193input_file() {
194 source="$1"
195 if [ -f "$1" ]; then
196 ${dep_list}header "$1"
Alex Landauc299ec22007-04-26 00:17:29 -0700197 is_cpio="$(echo "$1" | sed 's/^.*\.cpio\(\..*\)\?/cpio/')"
Jamey Sharp153f0112011-05-05 12:03:47 -0700198 if [ $2 -eq 0 -a ${is_cpio} = "cpio" ]; then
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200199 cpio_file=$1
Alex Landauc299ec22007-04-26 00:17:29 -0700200 echo "$1" | grep -q '^.*\.cpio\..*' && is_cpio_compressed="compressed"
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200201 [ ! -z ${dep_list} ] && echo "$1"
202 return 0
Linus Torvalds1da177e2005-04-16 15:20:36 -0700203 fi
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200204 if [ -z ${dep_list} ]; then
205 print_mtime "$1" >> ${output}
206 cat "$1" >> ${output}
207 else
Jason Gunthorpeb8341932010-03-22 16:49:32 -0600208 echo "$1 \\"
Sam Ravnborg46ed9812006-04-30 23:56:33 +0200209 cat "$1" | while read type dir file perm ; do
Jamey Sharp153f0112011-05-05 12:03:47 -0700210 if [ "$type" = "file" ]; then
Sam Ravnborg46ed9812006-04-30 23:56:33 +0200211 echo "$file \\";
212 fi
213 done
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200214 fi
215 elif [ -d "$1" ]; then
216 dir_filelist "$1"
Linus Torvalds1da177e2005-04-16 15:20:36 -0700217 else
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200218 echo " ${prog}: Cannot open '$1'" >&2
Linus Torvalds1da177e2005-04-16 15:20:36 -0700219 exit 1
220 fi
221}
222
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200223prog=$0
Linus Torvalds1da177e2005-04-16 15:20:36 -0700224root_uid=0
225root_gid=0
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200226dep_list=
227cpio_file=
228cpio_list=
229output="/dev/stdout"
230output_file=""
Alex Landauc299ec22007-04-26 00:17:29 -0700231is_cpio_compressed=
Michal Marek6ae9ecb2011-03-31 15:47:55 +0200232compr="gzip -n -9 -f"
Linus Torvalds1da177e2005-04-16 15:20:36 -0700233
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200234arg="$1"
235case "$arg" in
236 "-l") # files included in initramfs - used by kbuild
237 dep_list="list_"
Jason Gunthorpeb8341932010-03-22 16:49:32 -0600238 echo "deps_initramfs := $0 \\"
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200239 shift
240 ;;
Alain Knaffa26ee602009-01-07 00:10:27 -0800241 "-o") # generate compressed cpio image named $1
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200242 shift
243 output_file="$1"
244 cpio_list="$(mktemp ${TMPDIR:-/tmp}/cpiolist.XXXXXX)"
245 output=${cpio_list}
P J P9ba4bcb2013-11-12 15:10:22 -0800246 echo "$output_file" | grep -q "\.gz$" \
247 && [ -x "`which gzip 2> /dev/null`" ] \
248 && compr="gzip -n -9 -f"
249 echo "$output_file" | grep -q "\.bz2$" \
250 && [ -x "`which bzip2 2> /dev/null`" ] \
251 && compr="bzip2 -9 -f"
252 echo "$output_file" | grep -q "\.lzma$" \
253 && [ -x "`which lzma 2> /dev/null`" ] \
254 && compr="lzma -9 -f"
255 echo "$output_file" | grep -q "\.xz$" \
256 && [ -x "`which xz 2> /dev/null`" ] \
257 && compr="xz --check=crc32 --lzma2=dict=1MiB"
258 echo "$output_file" | grep -q "\.lzo$" \
259 && [ -x "`which lzop 2> /dev/null`" ] \
260 && compr="lzop -9 -f"
261 echo "$output_file" | grep -q "\.lz4$" \
262 && [ -x "`which lz4 2> /dev/null`" ] \
Daniel M. Weeks5ec384d2014-03-03 15:38:28 -0800263 && compr="lz4 -l -9 -f"
Alain Knaffa26ee602009-01-07 00:10:27 -0800264 echo "$output_file" | grep -q "\.cpio$" && compr="cat"
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200265 shift
266 ;;
267esac
Linus Torvalds1da177e2005-04-16 15:20:36 -0700268while [ $# -gt 0 ]; do
269 arg="$1"
270 shift
271 case "$arg" in
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200272 "-u") # map $1 to uid=0 (root)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700273 root_uid="$1"
274 shift
275 ;;
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200276 "-g") # map $1 to gid=0 (root)
Linus Torvalds1da177e2005-04-16 15:20:36 -0700277 root_gid="$1"
278 shift
279 ;;
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200280 "-d") # display default initramfs list
Linus Torvalds1da177e2005-04-16 15:20:36 -0700281 default_list="$arg"
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200282 ${dep_list}default_initramfs
Linus Torvalds1da177e2005-04-16 15:20:36 -0700283 ;;
284 "-h")
285 usage
286 exit 0
287 ;;
288 *)
289 case "$arg" in
290 "-"*)
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200291 unknown_option
Linus Torvalds1da177e2005-04-16 15:20:36 -0700292 ;;
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200293 *) # input file/dir - process it
294 input_file "$arg" "$#"
Linus Torvalds1da177e2005-04-16 15:20:36 -0700295 ;;
296 esac
297 ;;
298 esac
299done
300
Alain Knaffa26ee602009-01-07 00:10:27 -0800301# If output_file is set we will generate cpio archive and compress it
Lucas De Marchi25985ed2011-03-30 22:57:33 -0300302# we are careful to delete tmp files
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200303if [ ! -z ${output_file} ]; then
304 if [ -z ${cpio_file} ]; then
Michal Mareka8b80172011-03-31 23:16:42 +0200305 timestamp=
306 if test -n "$KBUILD_BUILD_TIMESTAMP"; then
307 timestamp="$(date -d"$KBUILD_BUILD_TIMESTAMP" +%s || :)"
308 if test -n "$timestamp"; then
309 timestamp="-t $timestamp"
310 fi
311 fi
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200312 cpio_tfile="$(mktemp ${TMPDIR:-/tmp}/cpiofile.XXXXXX)"
Michal Mareka8b80172011-03-31 23:16:42 +0200313 usr/gen_init_cpio $timestamp ${cpio_list} > ${cpio_tfile}
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200314 else
315 cpio_tfile=${cpio_file}
316 fi
317 rm ${cpio_list}
Alex Landauc299ec22007-04-26 00:17:29 -0700318 if [ "${is_cpio_compressed}" = "compressed" ]; then
319 cat ${cpio_tfile} > ${output_file}
320 else
Alain Knaffab59d3b2009-02-19 13:39:21 -0800321 (cat ${cpio_tfile} | ${compr} - > ${output_file}) \
322 || (rm -f ${output_file} ; false)
Alex Landauc299ec22007-04-26 00:17:29 -0700323 fi
Sam Ravnborgd39a206b2006-04-11 13:24:32 +0200324 [ -z ${cpio_file} ] && rm ${cpio_tfile}
325fi
Linus Torvalds1da177e2005-04-16 15:20:36 -0700326exit 0